//
//  ChocoLayerFilter.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 06.11.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ChocoLayer.h"


@interface ChocoLayerFilter : ChocoLayer 
{
	CIFilter *filter;
	CIFilter *filterDisplay;
	int isFilterFor;
	BOOL filterShowSettings;
	ChocoAccumulator* accuFilterMap;
	BOOL fMapMode;

}

-(void) modifyFilterWithScale:(float) rat andOffset:(CGPoint) pt;
-(void) setFilterInputImage:(CIImage*) inputImage forDownscaledVersion:(BOOL)downScaled;

-(BOOL) filterHasInput;

-(IBAction) restoreFilterMap: (ChocoAccumulator*) fMapAccu;
-(IBAction) restoreFilter:(CIFilter*) filterBackup;

-(void) loadAccuFilterMapAsTiffFromPath: (NSString*) path withFormat:(CIFormat)format;


-(CIFilter*) buildFilterFromXMLElement:(NSXMLElement*) el;

-(void) setFilter:(CIFilter*)f;
-(CIFilter*) getFilter;

-(void) setFMapMode:(BOOL)mode;
-(BOOL) getFMapMode;

-(void) setAccuFilterMap:(ChocoAccumulator*)ac;
-(ChocoAccumulator*) getAccuFilterMap;

-(void) setIsFilterFor:(int)sel;
-(BOOL) getIsFilterFor;

-(void) setFilterShowSettings:(BOOL)show;
-(BOOL) getFilterShowSettings;


-(CIFilter*) getFilterForDisplay;
-(void) updateFilterVariant:(CIFilter*) nFilter withRatio:(float) rat	;


@end
